package ne.sample.slidetopmenu;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "ne.sample.slidetopmenu", "ne.sample.slidetopmenu.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "ne.sample.slidetopmenu", "ne.sample.slidetopmenu.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "ne.sample.slidetopmenu.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner1 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner2 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner3 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner4 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner10 = null;
public b4a.example.slidetopmenu _slidemenu = null;
public static boolean _issearch = false;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 21;BA.debugLine="SlideMenu.Initialize(Activity, Me, \"SlideMenu\", 3";
mostCurrent._slidemenu._initialize(mostCurrent.activityBA,mostCurrent._activity,main.getObject(),"SlideMenu",(int) (300));
 //BA.debugLineNum = 22;BA.debugLine="SlideMenu.ContentPanel.LoadLayout(\"main\")";
mostCurrent._slidemenu._contentpanel.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 23;BA.debugLine="SlideMenu.AddMenu(0, 190dip)";
mostCurrent._slidemenu._addmenu((int) (0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (190)));
 //BA.debugLineNum = 24;BA.debugLine="SlideMenu.AddMenu(1, 370dip)";
mostCurrent._slidemenu._addmenu((int) (1),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (370)));
 //BA.debugLineNum = 25;BA.debugLine="SlideMenu.GetPanel(0).LoadLayout(\"search\")";
mostCurrent._slidemenu._getpanel((int) (0)).LoadLayout("search",mostCurrent.activityBA);
 //BA.debugLineNum = 26;BA.debugLine="SlideMenu.GetPanel(1).LoadLayout(\"search_advance\"";
mostCurrent._slidemenu._getpanel((int) (1)).LoadLayout("search_advance",mostCurrent.activityBA);
 //BA.debugLineNum = 28;BA.debugLine="Spinner10.AddAll(Array As String(\"Item1\", \"Item2\"";
mostCurrent._spinner10.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Item1","Item2","Item3","Item4","Item5"}));
 //BA.debugLineNum = 29;BA.debugLine="Spinner1.AddAll(Array As String(\"Test1\", \"Test2\",";
mostCurrent._spinner1.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Test1","Test2","Test3","Test4","Test5"}));
 //BA.debugLineNum = 30;BA.debugLine="Spinner2.AddAll(Array As String(\"Sample1\", \"Sampl";
mostCurrent._spinner2.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Sample1","Sample2","Sample3","Sample4","Sample5"}));
 //BA.debugLineNum = 31;BA.debugLine="Spinner3.AddAll(Array As String(\"Item1\", \"Item2\",";
mostCurrent._spinner3.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Item1","Item2","Item3","Item4","Item5"}));
 //BA.debugLineNum = 32;BA.debugLine="Spinner4.AddAll(Array As String(\"Criteria1\", \"Cri";
mostCurrent._spinner4.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Criteria1","Criteria2","Criteria3","Criteria4","Criteria5"}));
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
 //BA.debugLineNum = 42;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK AND SlideMenu.";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK && mostCurrent._slidemenu._state==1) { 
 //BA.debugLineNum = 43;BA.debugLine="SlideMenu.Hide";
mostCurrent._slidemenu._hide();
 //BA.debugLineNum = 44;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 46;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 47;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _btnadcancel_click() throws Exception{
 //BA.debugLineNum = 75;BA.debugLine="Sub btnAdCancel_Click";
 //BA.debugLineNum = 76;BA.debugLine="SlideMenu.Hide";
mostCurrent._slidemenu._hide();
 //BA.debugLineNum = 77;BA.debugLine="End Sub";
return "";
}
public static String  _btnadsearch_click() throws Exception{
 //BA.debugLineNum = 70;BA.debugLine="Sub btnAdSearch_Click";
 //BA.debugLineNum = 71;BA.debugLine="isSearch = True";
_issearch = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 72;BA.debugLine="SlideMenu.Hide";
mostCurrent._slidemenu._hide();
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _btnadvanced_click() throws Exception{
 //BA.debugLineNum = 62;BA.debugLine="Sub btnAdvanced_Click";
 //BA.debugLineNum = 63;BA.debugLine="SlideMenu.ChangeMenuTo(1)";
mostCurrent._slidemenu._changemenuto((int) (1));
 //BA.debugLineNum = 64;BA.debugLine="End Sub";
return "";
}
public static String  _btncancel_click() throws Exception{
 //BA.debugLineNum = 66;BA.debugLine="Sub btnCancel_Click";
 //BA.debugLineNum = 67;BA.debugLine="SlideMenu.Hide";
mostCurrent._slidemenu._hide();
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}
public static String  _btnsearch_click() throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub btnSearch_Click";
 //BA.debugLineNum = 58;BA.debugLine="isSearch = True";
_issearch = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 59;BA.debugLine="SlideMenu.Hide";
mostCurrent._slidemenu._hide();
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _btnshowadvancedsearch_click() throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Sub btnShowAdvancedSearch_Click";
 //BA.debugLineNum = 54;BA.debugLine="SlideMenu.Show(1)";
mostCurrent._slidemenu._show((int) (1));
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _btnshowsearch_click() throws Exception{
 //BA.debugLineNum = 49;BA.debugLine="Sub btnShowSearch_Click";
 //BA.debugLineNum = 50;BA.debugLine="SlideMenu.Show(0)";
mostCurrent._slidemenu._show((int) (0));
 //BA.debugLineNum = 51;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 14;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 15;BA.debugLine="Dim Spinner1, Spinner2, Spinner3, Spinner4, Spinn";
mostCurrent._spinner1 = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spinner2 = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spinner3 = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spinner4 = new anywheresoftware.b4a.objects.SpinnerWrapper();
mostCurrent._spinner10 = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 16;BA.debugLine="Dim SlideMenu As SlideTopMenu";
mostCurrent._slidemenu = new b4a.example.slidetopmenu();
 //BA.debugLineNum = 17;BA.debugLine="Dim isSearch As Boolean = False";
_issearch = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 12;BA.debugLine="End Sub";
return "";
}
public static String  _slidemenu_state(int _state) throws Exception{
 //BA.debugLineNum = 79;BA.debugLine="Sub SlideMenu_State(State As Int)";
 //BA.debugLineNum = 80;BA.debugLine="If State = 0 Then";
if (_state==0) { 
 //BA.debugLineNum = 81;BA.debugLine="If isSearch Then";
if (_issearch) { 
 //BA.debugLineNum = 82;BA.debugLine="Msgbox(\"Search Clicked...\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Search Clicked...","",mostCurrent.activityBA);
 };
 };
 //BA.debugLineNum = 85;BA.debugLine="isSearch = False";
_issearch = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 86;BA.debugLine="End Sub";
return "";
}
}
